@echo off
:: CONFIG for emTeX
:: (C) Cezary M. Kruk, ul. Zielonogorska 7 m. 2, 53-617 Wroclaw, Poland

:SET0
set ask=
set dsk=
set latex=
set tools=
set tex=
set size=
set f=
set b=
set s=
set hpkey=
set hpdsc=
set prefix=
set hyph=
set cpkey=
set mode=
set pfx=
set res=
set x=
set a=

:SET0_0
set BIBINPUT=
set BMFBAS=
set BTEXFMT=
set EMTEXDRV=
set MFBAS=
set MFINPUT=
set MFJOB=
set TEXFMT=
set TEXINPUT=
set TEXTFM=
set DVIDRVINPUT=
set DVIDRVGRAPH=
if not "%oldpath%"=="" PATH %oldpath%
if "%oldpath%"=="" set oldpath=%PATH%

:PARAMS
if "%1"=="" goto ENVSPACE
if "%1"=="/?" goto ERR0
if "%1"=="\?" goto ERR1
if not "%1"=="%source%" goto ERR2
if not "%3"=="%target%" goto ERR2

:TARGET
cd \
cd %target%emtex
if not exist %target%emtex\nul goto ERR3

:FILES
if not exist config.mds goto ERR4

:ASK
set ask=%target%emtex\ask.exe

:MS-DOS
ver | find "MS-DOS" > ver.dos
copy ver.dos dos.ver > nul
del ver.dos
if exist dos.ver goto TEMP_0
ver | find "Windows" > ver.dos
copy ver.dos dos.ver > nul
del ver.dos
if not exist dos.ver goto ERR5

:TEMP_0
if not exist %target%temp.dir goto TEMP_1
copy %target%temp.dir %target%temp.bak > nul
del %target%temp.dir

:TEMP_1
if not exist %target%temp.dir\nul md %target%temp.dir

:ENVSPACE
set A=12345678901234567890123456789012345678901234567890
set B=%A%
set C=%A%
set D=%A%
if not "%1"=="" set E=%A%
if not "%1"=="" set F=%A%
if not "%1"=="" set G=%A%
if not "%1"=="" set H=%A%
set I=12345678901234567890123456789012
set A=
set B=
set C=
set D=
set E=
set F=
set G=
set H=
if not "%I%"=="12345678901234567890123456789012" goto ERR6
set I=
if not "%1"=="" goto INSTALL

:CONFIG_0
if not exist config.aux goto ERR7
if not exist config.mds goto ERR8
copy config.aux ..\target.bat > nul
cd ..
cd >> target.bat
call target.bat
del target.bat
if not exist emtex\config.bat goto ERR9
set ask=%target%emtex\bin\ask.exe
if not exist %ask% set target=%target%\
set ask=%target%emtex\bin\ask.exe
if not exist %ask% goto ERR10
cd emtex

:INSTALL
if "%1"=="" goto CONFIG

:BEGIN
cls
%ask% Do you want to unpack programs? ,yYnN-
echo.
if errorlevel 5 goto INSTALL
if errorlevel 3 goto CONFIG

:L2EMACRO
%ask% Do you want additional macros for LaTeX2e? ,yYnN-
echo.
if errorlevel 5 goto BEGIN
if errorlevel 3 goto LATEX209
if errorlevel 1 set tools=yes

:LATEX209
%ask% Do you want old LaTeX 2.09? ,yYnN-
echo.
if errorlevel 5 goto BEGIN
if errorlevel 3 goto UNPACK
if errorlevel 1 set latex=old

:UNPACK
echo.
echo Unpacking requires
if "%latex%"=="" if "%tools%"=="" echo                       12.700.000 bytes free disk space
if "%latex%"=="old" if "%tools%"=="" echo                       13.400.000 bytes free disk space
if "%latex%"=="" if "%tools%"=="yes" echo                       13.900.000 bytes free disk space
if "%latex%"=="old" if "%tools%"=="yes" echo                       14.650.000 bytes free disk space
echo.
echo Drive %dd% has
dir | find "bytes free"
dir | find "bajtw wolnych"
echo.
echo.
%ask% Have you got enough disk space? ,yYnN-
echo.
if errorlevel 5 goto BEGIN
if errorlevel 3 goto END
shift
shift
shift

:T1
:: Documentation files and tools, to be installed first
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%first.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%first.zip pause
unzip %source%%root%first -d %target%
echo.
if not exist remove\first.rem pause
shift

:T2
:: emx and rsx runtime package (for tex386 etc.)
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%emxrsx.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%emxrsx.zip pause
unzip %source%%root%emxrsx -d %target%
echo.
if not exist remove\emxrsx.rem pause
shift

:T3
:: Printer drivers and screen previewers, part 1 of 2
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%%dvi1%.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%%dvi1%.zip pause
unzip %source%%root%%dvi1% -d %target%
echo.
if not exist remove\dvi*.rem pause
shift

:T4
:: Printer drivers and screen previewers, part 2 of 2
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%%dvi2%.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%%dvi2%.zip pause
unzip %source%%root%%dvi2% -d %target%
echo.
if not exist data\fontlist pause
shift

:T5
:: Files for typesetting documents written in German
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%german.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%german.zip pause
unzip %source%%root%german -d %target%
echo.
if not exist remove\german.rem pause
shift

:T6
:: emTeX typesetter
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%%tex0%.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%%tex0%.zip pause
unzip %source%%root%%tex0% -d %target%
echo.
if not exist remove\%tex0%.rem pause
shift

:T7
:: METAFONT: generating fonts
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%%mf%.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%%mf%.zip pause
unzip %source%%root%%mf% -d %target%
echo.
if not exist remove\%mf%.rem pause
shift

:T8
:: Font source files and TFM files: Computer Modern
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%fontcm.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%fontcm.zip pause
unzip %source%%root%fontcm -d %target%
echo.
if not exist remove\fontcm.rem pause
shift

:T9
:: Font source files and TFM files: LaTeX fonts
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%fontltx.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%fontltx.zip pause
unzip %source%%root%fontltx -d %target%
echo.
if not exist remove\fontltx.rem pause
shift

:T10
:: MFjob: assists METAFONT in generating fonts
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%%mfj%.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%%mfj%.zip pause
unzip %source%%root%%mfj% -d %target%
echo.
if not exist remove\%mfj%.rem pause
shift

:T11
:: Unpacked input files of LaTeX2e
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%l2input.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%l2input.zip pause
unzip %source%%root%l2input -d %target%
echo.
if not exist remove\l2input.rem pause
shift

if "%tools%"=="" goto NOTOOLS

:T12
:: Additional macros for LaTeX2e
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%l2tools.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%l2tools.zip pause
unzip %source%%root%l2tools -d %target%
echo.
if not exist remove\l2tools.rem pause

:NOTOOLS
shift

if "%latex%"=="" goto NOLATEX

:T13
:: LaTeX 2.09 macro package
cls
if not "%root%"=="" set root=tex_%1\
if not exist %source%%root%latex209.zip echo Insert disk `TEX_%1' in drive %source%
echo.
if not exist %source%%root%latex209.zip pause
unzip %source%%root%latex209 -d %target%
echo.
if not exist remove\latex209.rem pause

:NOLATEX

:SET0_1
set mfj=
set dvi1=
set dvi2=
set tex0=
set mf=

:COPYDEL
if exist bin\set_tex.bat del bin\set_tex.bat
echo @echo off> bin\install.bat
echo %dd%>> bin\install.bat
echo cd %target%emtex>> bin\install.bat
echo config.bat>> bin\install.bat
copy ask.exe bin\ask.exe > nul
copy unzip.exe bin\unzip.exe > nul

:CONFIG
if not exist %target%emtex\texinput\nul goto END
set EMTEXDIR=%target%EMTEX
cls
%ask% Do you want to configure system? ,yYnN-
echo.
if errorlevel 5 if "%1"=="" goto INSTALL
if errorlevel 5 if not "%1"=="" goto CONFIG
if errorlevel 3 goto END
echo.

:PRINTER
cls
set mode=
set pfx=
set res=
%ask% Have you got a printer? ,yYnN-
echo.
if errorlevel 5 goto CONFIG
if errorlevel 3 goto SLOWFAST
echo         PRINTER
echo     ----------------------------------
echo     a.  Canon BubbleJet (360 DPI)
echo     b.  HP DeskJet (300 DPI)
echo     c.  Fax (204x196 DPI)
echo     d.  9-pin printers (240x216 DPI)
echo     e.  C.ITOH 8510A (160x144 DPI)
echo     f.  HP LaserJet (300 DPI)
echo     g.  HP LaserJet 4 (600 DPI)
echo     h.  24-pin printers (360 DPI)
echo     i.  24-pin printers (180 DPI)
echo     j.  24-pin printers (360x180 DPI)
echo     k.  HP QuietJet (192 DPI)
echo     l.  EPSON Stylus 800 (360 DPI)
echo     *.  OTHER
echo.
%ask% Choose printer type: ,aAbBcCdDeEfFgGhHiIjJkKlL*-
echo.
if errorlevel 26 goto PRINTER
if errorlevel 25 goto OTHER
if errorlevel 23 goto STY
if errorlevel 21 goto QJ
if errorlevel 19 goto P6M
if errorlevel 17 goto P6L
if errorlevel 15 goto P6H
if errorlevel 13 goto LJH
if errorlevel 11 goto LJ
if errorlevel 9  goto ITO
if errorlevel 7  goto FX
if errorlevel 5  goto FAX
if errorlevel 3  goto DJ
if errorlevel 1  goto BJ

:SLOWFAST
cls
%ask% Do you want HP LaserJet for fast machine or 24-pin printer for slow one? ,yYnN-
echo.
if errorlevel 5 goto PRINTER
if errorlevel 3 goto SPACE
echo.
%ask% Have you got a fast machine? ,yYnN-
echo.
if errorlevel 5 goto SLOWFAST
if errorlevel 3 goto P6L
goto LJ

:BJ
set mode=bj
set pfx=bj
set res=360
goto SPACE

:DJ
set mode=dj
set pfx=dj
set res=300
goto SPACE

:FAX
set mode=FAX
set pfx=fax
set res=204
goto SPACE

:FX
set mode=fx
set pfx=fx
set res=240
goto SPACE

:ITO
set mode=ito
set pfx=ito
set res=160
goto SPACE

:LJ
set mode=lj
set pfx=lj
set res=300
goto SPACE

:LJH
set mode=ljh
set pfx=ljh
set res=600
goto SPACE

:P6H
set mode=lqh
set pfx=p6h
set res=360
goto SPACE

:P6L
set mode=lql
set pfx=p6l
set res=180
goto SPACE

:P6M
set mode=lqm
set pfx=p6m
set res=360
goto SPACE

:QJ
set mode=qj
set pfx=qj
set res=192
goto SPACE

:STY
set mode=sty
set pfx=sty
set res=360
goto SPACE

:OTHER
echo.
echo See `Users's Guide' for your printer compatibility.
echo.
pause

:SPACE
cls
echo Configuration requires
echo BASIC  from 400.000 to 2.100.000 bytes free disk space
cd %EMTEXDIR%
if exist dist\latex\packages\tools\tools.ins echo L2ETOOLS                 400.000 bytes
if exist texinput\latex209\lplain.tex echo LATEX209                 850.000 bytes
goto F_%pfx%

:F_ITO
echo FONTLIB                  800.000 bytes
goto DRIVE

:F_P6L
:F_QJ
echo FONTLIB                1.200.000 bytes
goto DRIVE

:F_FAX
:F_FX
echo FONTLIB                1.300.000 bytes
goto DRIVE

:F_P6M
echo FONTLIB                1.400.000 bytes
goto DRIVE

:F_LJ
:F_DJ
echo FONTLIB                1.600.000 bytes
goto DRIVE

:F_BJ
:F_P6H
:F_STY
echo FONTLIB                1.800.000 bytes
goto DRIVE

:F_LJH
echo FONTLIB                2.900.000 bytes

:F_

:DRIVE
echo.
echo Drive %target% has got
dir | find "bytes free"
dir | find "bajtw wolnych"
echo.
echo.
%ask% Have you got enough disk space? ,yYnN-
echo.
if errorlevel 5 goto CONFIG
if errorlevel 3 goto END

:EXTTEX
cls
set tex=
echo         EXTENDED TEX
echo     ------------------
echo     1.  std
echo     2.  186
echo     3.  386
echo.
%ask% Do you want an extended version of TeX? ,123-
echo.
if errorlevel 4 goto PRINTER
if errorlevel 3 goto TEX386
if errorlevel 2 goto TEX186

:TEX
set tex=
set MFJOBOPT=
goto BIGTEX

:TEX186
set tex=186
set MFJOBOPT=/1
goto BIGTEX

:TEX386
set tex=386
set MFJOBOPT=/3

:BIGTEX
set size=
echo.
echo         BIG TEX
echo     ------------------
if "%tex%"=="386" echo     1.  ***
if not "%tex%"=="386" echo     1.  std
echo     2.  big
if "%tex%"=="386" echo     3.  huge
if not "%tex%"=="386" echo     3.  ***
echo.
if "%tex%"=="386" set size=~23-
if not "%tex%"=="386" set size=12~-
%ask% Do you want a big version of TeX? ,%size%
echo.
if errorlevel 4 goto EXTTEX
if "%tex%"=="386" if errorlevel 3 goto HUGE
if "%tex%"=="386" if errorlevel 2 goto SMALL
if errorlevel 2 goto BIG

:SMALL
set size=
set f=
set b=
set s=
if "%tex%"=="386" set f=b
if "%tex%"=="386" set b=b
goto SET1

:BIG
set size=big
set f=b
set b=b
set s=b
set MFJOBOPT=/b%MFJOBOPT%
goto SET1

:HUGE
set size=huge
set f=h
set b=b
set s=h

:SET1
if "%a%"=="*" goto FORMAT
cd %EMTEXDIR%
echo @ECHO OFF>a
echo SET OLDPATH=%OLDPATH%>>a

:PATH1
echo PATH %PATH%;%EMTEXDIR%\BIN>>a
if not exist %target%emx\bin\emx.exe goto SET_CNT1
echo SET EMX=%target%EMX\BIN\EMX.EXE>>a

:SET_CNT1
echo SET EMTEXDIR=%EMTEXDIR%>>a
if not exist %DVIDRVFONTS%\nul set DVIDRVFONTS=
if "%DVIDRVFONTS%"=="" set DVIDRVFONTS=%target%TEXFONTS
echo SET DVIDRVFONTS=%DVIDRVFONTS%>>a
echo SET TMP=%target%TEMP.DIR>> autoexec.log
if not "%MFJOBOPT%"=="" echo SET MFJOBOPT=%MFJOBOPT%>>a
echo SET EMTEXED=%EMTEXED%>>a

:EXEC
copy a autoexec.log > nul
del a
copy autoexec.log exec.bat > nul
call exec.bat
del exec.bat
echo SET>> autoexec.log
copy autoexec.log bin\set_tex.bat > nul
set a=*

:FORMAT
cls
%ask% Do you want to prepare TeX and LaTeX format files? ,yYnN-
echo.
if errorlevel 5 goto EXTTEX
if errorlevel 3 goto L2ETOOLS

:REFORMAT
echo         HYPHENATION
echo     ----------------------------------
echo     a.  US English
echo     b. *US English, extended
echo     c. *UK English
echo     d. *Catalan
echo     e. *Danish
echo     f. *Dutch
echo     g.  German
echo     h. *Italian
echo     i. *Polish
echo     j. *Portuguese
echo     k. *Russian
echo     l. *Spanish
echo     m. *Swedish
echo     *.  NONE
echo.
echo        *Hyphenation patterns not allowed in the standard package.
echo.
%ask% Select hyphenation: ,aAbBcCdDeEfFgGhHiIjJkKlLmM*-
echo.
if errorlevel 28 goto FORMAT
if errorlevel 27 goto L2ETOOLS
if errorlevel 25 goto SE
if errorlevel 23 goto ES
if errorlevel 21 goto SU
if errorlevel 19 goto PT
if errorlevel 17 goto PO
if errorlevel 15 goto IT
if errorlevel 13 goto G
if errorlevel 11 goto NE
if errorlevel 9  goto DK
if errorlevel 7  goto CA
if errorlevel 5  goto UK
if errorlevel 3  goto USEXT

:US
set hpkey=US
set hpdsc=US English
set prefix=
set hyph=hyphen
goto HYPHEN

:USEXT
set hpkey=USext
set hpdsc=US English, extended
set prefix=us
set hyph=ushyph
goto HYPHEN

:UK
set hpkey=UK
set hpdsc=UK English
set prefix=uk
set hyph=ukhyph
goto HYPHEN

:CA
set hpkey=Catalan
set hpdsc=Catalan
set prefix=ca
set hyph=cahyph
goto HYPHEN

:DK
set hpkey=Danish
set hpdsc=Danish
set prefix=dk
set hyph=dkhyph
goto HYPHEN

:NE
set hpkey=Dutch
set hpdsc=Dutch
set prefix=ne
set hyph=nehyph2
goto HYPHEN

:G
set hpkey=German
set hpdsc=German
set prefix=g
set hyph=ghyph31
goto HYPHEN

:IT
set hpkey=Italian
set hpdsc=Italian
set prefix=it
set hyph=ithyph
goto HYPHEN

:PO
set hpkey=Polish
set hpdsc=Polish
set prefix=po
set hyph=pohyph
goto HYPHEN

:PT
set hpkey=Portuguese
set hpdsc=Portuguese
set prefix=pt
set hyph=pthyph
goto HYPHEN

:SU
set hpkey=Russian
set hpdsc=Russian
set prefix=su
set hyph=suhyph
goto HYPHEN

:ES
set hpkey=Spanish
set hpdsc=Spanish
set prefix=es
set hyph=eshyph
goto HYPHEN

:SE
set hpkey=Swedish
set hpdsc=Swedish
set prefix=se
set hyph=sehypha

:HYPHEN
if "%hyph%"=="hyphen" goto CODEPAGE
cd %EMTEXDIR%
if exist texinput\%hyph%.tex goto CODEPAGE
if exist texinput\%hpkey%\%hyph%.tex goto CODEPAGE
echo Cannot find format files:
echo `%target%EMTEX\TEXINPUT\%hyph%.tex', nor
echo `%target%EMTEX\TEXINPUT\%hpkey%\%hyph%.tex'.
echo.
pause
goto BACK

:CODEPAGE
cls
echo         CODEPAGE
echo     ----------------------------------
echo     1.  No codepage translation
echo     2.  Pass-through codes 128--255
echo     3.  Codepage 850---TeX commands
echo     4.  Codepage 850---Cork encoding
echo.
%ask% Select codepage: ,1234-
echo.
if errorlevel 5 goto FORMAT
if errorlevel 4 goto CPC
if errorlevel 3 goto CPT
if errorlevel 2 goto CP8
if errorlevel 1 goto PLAIN

:CP8
set cpkey=8bit
goto PLAIN

:CPT
set cpkey=850tex
goto PLAIN

:CPC
set cpkey=850cork

:PLAIN
cls
%ask% Do you want plain TeX, %hpdsc% hyphenation? ,yYnN-
echo.
if errorlevel 5 goto FORMAT
if errorlevel 3 goto LATEX2E
cd %EMTEXDIR%\%f%texfmts
if "%tex%"=="386" if "%size%"=="" set size=386
if "%prefix%"=="" call makefmt %size% plain %hpkey% %cpkey% -f plain -b %EMTEXDIR%\bin\plain -e
if not "%prefix%"=="" call makefmt %size% plain %hpkey% %cpkey% -f plain%prefix% -b %EMTEXDIR%\bin\%prefix%plain -e
if "%size%"=="386" set size=
cd %EMTEXDIR%
echo. >> command.log
echo ------------------------------------------------------ >> command.log
echo     PROGRAM  : %s%tex%tex%.exe >> command.log
echo     FORMAT   : %hpdsc% hyphenation >> command.log
echo     COMMAND  : %prefix%plain >> command.log
echo. >> command.log
if "%cpkey%"=="8bit" echo     Pass-through codes 128--255 >> command.log
if "%cpkey%"=="850tex" echo     Codepage 850---TeX commands >> command.log
if "%cpkey%"=="850cork" echo     Codepage 850---Cork encoding >> command.log
echo ------------------------------------------------------ >> command.log

:LATEX2E
cls
%ask% Do you want LaTeX2e, %hpdsc% hyphenation? ,yYnN-
echo.
if errorlevel 5 goto PLAIN
if errorlevel 3 goto LATEX
cd %EMTEXDIR%\%f%texfmts
if "%tex%"=="386" if "%size%"=="" set size=386
if "%prefix%"=="" call makefmt %size% latex2e %hpkey% %cpkey% -f latex2e -b %EMTEXDIR%\bin\latex2e -e
if not "%prefix%"=="" call makefmt %size% latex2e %hpkey% %cpkey% -f ltx2e%prefix% -b %EMTEXDIR%\bin\%prefix%ltx2e -e
if "%size%"=="386" set size=
cd %EMTEXDIR%
echo. >> command.log
echo ------------------------------------------------------ >> command.log
echo     PROGRAM  : %s%tex%tex%.exe >> command.log
echo     FORMAT   : %hpdsc% hyphenation >> command.log
if "%prefix%"=="" echo     COMMAND  : latex2e >> command.log
if not "%prefix%"=="" echo     COMMAND  : %prefix%ltx2e >> command.log
echo. >> command.log
if "%cpkey%"=="8bit" echo     Pass-through codes 128--255 >> command.log
if "%cpkey%"=="850tex" echo     Codepage 850---TeX commands >> command.log
if "%cpkey%"=="850cork" echo     Codepage 850---Cork encoding >> command.log
echo ------------------------------------------------------ >> command.log

:LATEX
if not exist %EMTEXDIR%\texinput\latex209\lplain.tex goto BACK
cls
%ask% Do you want LaTeX 2.09, %hpdsc% hyphenation? ,yYnN-
echo.
if errorlevel 5 goto LATEX
if errorlevel 3 goto BACK
cd %EMTEXDIR%\%f%texfmts
if "%tex%"=="386" if "%size%"=="" set size=386
if "%prefix%"=="" call makefmt %size% latex209 %hpkey% %cpkey% -f latex -b %EMTEXDIR%\bin\latex209 -e
if not "%prefix%"=="" call makefmt %size% latex209 %hpkey% %cpkey% -f ltx%prefix% -b %EMTEXDIR%\bin\%prefix%ltx209 -e
if "%size%"=="386" set size=
cd %EMTEXDIR%
echo. >> command.log
echo ------------------------------------------------------ >> command.log
echo     PROGRAM  : %s%tex%tex%.exe >> command.log
echo     FORMAT   : %hpdsc% hyphenation >> command.log
if "%prefix%"=="" echo     COMMAND  : latex209 >> command.log
if not "%prefix%"=="" echo     COMMAND  : %prefix%ltx209 >> command.log
echo. >> command.log
if "%cpkey%"=="8bit" echo     Pass-through codes 128--255 >> command.log
if "%cpkey%"=="850tex" echo     Codepage 850---TeX commands >> command.log
if "%cpkey%"=="850cork" echo     Codepage 850---Cork encoding >> command.log
echo ------------------------------------------------------ >> command.log

:BACK
cls
%ask% Do you want another language format files? ,yYnN-
echo.
if errorlevel 5 goto REFORMAT
if errorlevel 3 goto L2ETOOLS
if errorlevel 1 goto REFORMAT

:L2ETOOLS
cd %EMTEXDIR%
if not exist bin\latex.bat goto PLAINBAS
if not exist dist\latex\packages\tools\tools.ins goto PLAINBAS
if exist texinput\latex2e\layout.sty goto PLAINBAS
cls
%ask% Do you want additional macros for LaTeX2e? ,yYnN-
echo.
if errorlevel 5 goto BACK
if errorlevel 3 goto PLAINBAS
cd %EMTEXDIR%\dist\latex\packages\tools
call latex tools.ins
echo.
if exist *.tex copy *.tex %EMTEXDIR%\texinput\latex2e > nul
if exist *.sty copy *.sty %EMTEXDIR%\texinput\latex2e > nul
if exist *.tex del *.tex > nul
if exist *.sty del *.sty > nul

:PLAINBAS
if "%pfx%"=="" goto MODES
cd %EMTEXDIR%\bin
echo @echo off> v.bat
echo dvidrv dviscr @%pfx% /fl=-1 /ocr=1 %%1 %%2 %%3 %%4 %%5 %%6 %%7 %%8 %%9>> v.bat
echo @echo off> vs.bat
echo dvidrv dviscrs @%pfx% /fl=-1 /ocr=1 %%1 %%2 %%3 %%4 %%5 %%6 %%7 %%8 %%9>> vs.bat
if exist %EMTEXDIR%\%b%mfbases\plain.bas goto CMBAS
cls
%ask% Do you want to create the `plain' base file? ,yYnN-
echo.
if errorlevel 5 goto BACK
if errorlevel 3 goto MODES
cd %EMTEXDIR%\%b%mfbases
if not "%tex%"=="386" call makebas %size% plain
if "%tex%"=="386" call makebas %tex% plain

:CMBAS
if exist %EMTEXDIR%\%b%mfbases\cm.bas goto FONT
cls
%ask% Do you want to create the `cm' base file? (optional) ,yYnN-
echo.
if errorlevel 5 goto BACK
if errorlevel 3 goto FONT
cd %EMTEXDIR%\%b%mfbases
if not "%tex%"=="386" call makebas %size% cm
if "%tex%"=="386" call makebas %tex% cm

:FONT
if "%pfx%"=="" goto MODES
if not exist %EMTEXDIR%\%b%mfbases\plain.bas goto MODES
cls
%ask% Do you want to generate `*.pk' fonts? ,yYnN-
echo.
if errorlevel 5 goto BACK
if errorlevel 3 goto MODES

:MFJOB
echo.
echo Font generation takes a lot of time, but saves time later.
echo.
%ask% Do you really want to generate `*.pk' fonts? ,yYnN-
echo.
if errorlevel 5 goto FONT
if errorlevel 3 goto MODES
echo.
cd %EMTEXDIR%
echo def target=[%target%texfonts];>> modes.tmp
echo.>> modes.tmp
type config.mds >> modes.tmp
copy modes.tmp mfjob\modes.mfj > nul
if not exist %target%texfonts\nul md %target%texfonts
cd %target%texfonts
mfjob base m=%mode%

:BASELIB
cls
%ask% Do you want to generate the library of available fonts? ,yYnN-
echo.
if errorlevel 5 goto FONT
if errorlevel 3 goto MODES
if exist %pfx%_base.fli goto BASEBAK
goto MORELIB

:BASEBAK
%ask% Do you want to rename %pfx%_base.fli to %pfx%_base.bk? ,yYnN-
echo.
if errorlevel 5 goto BASELIB
if errorlevel 3 goto MODES
if exist %pfx%_base.bk del %pfx%_base.bk
ren %pfx%_base.fli %pfx%_base.bk

:MORELIB
call fli_base %pfx% %res% %target%texfonts
if not exist %pfx%_more.fli fontlib /c %pfx%_more

:LIBTEST
cls
echo Watch the screen to view the test of the font library.
echo.
pause
echo.
fontlib /t %pfx%_base
echo.
echo If the font library is `OK', you can remove `*.pk' fonts.
echo.
pause

:EMDELPK
cls
%ask% Do you want to remove `*.pk' fonts, `*.log' files, and copies of `*.tfm'? ,yYnN-
echo.
if errorlevel 5 goto LIBTEST
if errorlevel 3 goto MODES
emdelete -ry %target%texfonts\pixel.%pfx%
emdelete -ry %target%texfonts\log
emdelete -ry %target%texfonts\tfm

:MODES
cls
cd %EMTEXDIR%
echo %%> modes.tmp
echo %% This is file `modes.mfj', generated>> modes.tmp
echo %% with CONFIG from `config.mds'.>> modes.tmp
echo %%>> modes.tmp
echo def target=[%target%newfonts];>> modes.tmp
echo.>> modes.tmp
type config.mds >> modes.tmp
copy modes.tmp mfjob\modes.mfj > nul
del modes.tmp

:EMDELOS2
if not exist %EMTEXDIR%\bin\dvipm*.* goto TEST
cls
%ask% Do you want to remove OS/2 files? ,yYnN-
echo.
if errorlevel 5 goto FONT
if errorlevel 3 goto TEST
cd %EMTEXDIR%
if exist book\nul emdelete -ry book
if exist dll\nul emdelete -ry dll
if exist help\nul emdelete -ry help
if exist bin\*.cmd del bin\*.cmd
if exist bin\bmfp.exe del bin\bmfp.exe
if exist bin\btexp.exe del bin\btexp.exe
if exist bin\dvipm*.* del bin\dvipm*.*
if exist bin\mfp.exe del bin\mfp.exe
if exist bin\texp.exe del bin\texp.exe
cd %target%emx
if exist book\nul emdelete -ry book
if exist dll\nul emdelete -ry dll
if exist bin\*.cmd del bin\*.cmd

:TEST
if not exist %EMTEXDIR%\bin\latex2e.bat goto USER_0
cls
%ask% Do you want to test installation? ,yYnN-
echo.
if errorlevel 5 goto EMDELOS2
if errorlevel 3 goto USER_0
if not exist %target%test.tex\nul md %target%test.tex
cd %target%test.tex
call latex2e sample2e
echo.
echo.
echo Search for sample2e.dvi in `%target%TEST.TEX' directory.
echo.
pause

:USER_0
cd %EMTEXDIR%
if exist user.bat goto USER_1
if exist bin\user.bat goto USER_1
goto HELP

:USER_1
cls
%EMTEXDIR%\bin\ask Do you want to call user.bat? ,yYnN-
echo.
if errorlevel 5 goto EMDELOS2
if errorlevel 3 goto HELP
call user.bat

:HELP
cls
echo ATTENTION:
echo.
echo Update environment variables in your AUTOEXEC.BAT, according to the logging
echo stored in AUTOEXEC.LOG, or rename AUTOEXEC.LOG to e.g. SET_TEX.BAT, and run
echo it before each new session.
echo.
echo See COMMAND.LOG for all available formats and commands.
echo.
echo Do not remove CONFIG.AUX, CONFIG.MDS, and CONFIG.BAT.
echo.
echo.
echo Press any key to continue...
pause > nul
echo.
goto END

:ERR0
echo Helps in configuration of emTeX.
goto END2

:ERR1
echo CONFIG 1H, Cezary M. Kruk, 1997.
goto END2

:ERR2
echo CONFIG: Parameter format not correct.
goto END2

:ERR3
echo INSTALL: Parameter format not correct. Remove %target% directory.
goto END2

:ERR4
echo CONFIG.MDS not found.
goto END

:ERR5
echo Incorrect OS system. INSTALL requires MS-DOS 3.30 or later.
goto END

:ERR6
echo Insufficient environment space or program started from some shell.
set I=
goto END

:END
set dd=
set ask=
set root=
set latex=
set tools=
set tex=
set size=
set f=
set b=
set s=
set hpkey=
set hpdsc=
set prefix=
set hyph=
set cpkey=
set mode=
set pfx=
set res=
set a=

:X
if "%source%"=="" goto END2
if exist %target%emtex\bin\nul goto DEL
cd %target%temp.dir
echo @echo off> x.bat
echo if exist %target%EMTEX\config.* del %target%EMTEX\config.*>> x.bat
echo if "%%x%%"=="" echo Please remove x.bat from `%target%TEMP.DIR' directory.>> x.bat
echo if "%%x%%"=="" echo.>> x.bat
echo set target=>> x.bat
echo set x=>> x.bat
set x=*

:DEL
cd %target%emtex
if exist unzip.exe del unzip.exe
if exist ask.exe del ask.exe
if exist install.bat del install.bat
if exist dos.ver del dos.ver
goto END1

:ERR7
echo CONFIG.AUX not found.
goto END2

:ERR8
echo CONFIG.MDS not found.
goto END2

:ERR9
echo CONFIG.BAT must stay in EMTEX directory.
goto END2

:ERR10
echo %target%EMTEX\BIN\ASK.EXE not found.
goto END2

:END1
if "%x%"=="*" if exist %target%temp.dir\x.bat %target%temp.dir\x.bat

:END2
if exist %target%temp.dir\x.bat del %target%temp.dir\x.bat
set source=
set target=
